/*  A program to build from 3 parts a composite which can then be used as the
 *  'data' for constructing a pixmap.
 *
 *  Written by:  Ross Maloney
 *  Date:        April 2012
 */

//#define  TRAY_SIZE 5000
#define  TRAY_SIZE 500000

#include <stdio.h>
#include <stdlib.h>
#include "triangle.xbm"
#include "../lettering/inbook.xbm"
//#include "ross.xbm"
//#include "smalltri.xbm"
//#include "../labels/search.xbm"
//#include "../labels/showall.xbm"
//#include "../labels/bykey.xbm"
//#include "ellipsis.xbm"
//#include "../labels/print.xbm"
//#include "../lettering/error.xbm"
//#include "../lettering/ok.xbm"
//#include "../labels/closeout.xbm"
//#include "../labels/closein.xbm"
//#include "../labels/new.xbm"
//#include "../labels/read.xbm"
//#include "../labels/append.xbm"
//#include "../labels/open.xbm"
//#include "../labels/quit.xbm"
//#include "../lettering/article.xbm"
//#include "../lettering/inreference.xbm"
//#include "../lettering/aued.xbm"
#include "../lettering/howpublished.xbm"
//#include "../lettering/eventtitle.xbm"
//#include "../lettering/eventdate.xbm"
//#include "../lettering/venue.xbm"
//#include "../lettering/recall.xbm"
//#include "../lettering/cancel.xbm"
//#include "../lettering/append2.xbm"
//#include "../lettering/openN.xbm"
//#include "../lettering/do.xbm"
#include "../lettering/bookinbook.xbm"
#include "../lettering/year.xbm"
#include "../lettering/suppbook.xbm"
#include "../lettering/suppperiod.xbm"
//#include "../lettering/existingN.xbm"
#include "../lettering/author.xbm"
#include "../lettering/authortype.xbm"
//#include "../lettering/read2.xbm"
#include "../lettering/date.xbm"
#include "../lettering/title.xbm"
#include "../lettering/type.xbm"
#include "../lettering/holder.xbm"
#include "../lettering/journaltitle.xbm"
#include "../lettering/jsubtitle.xbm"
#include "../lettering/shjournal.xbm"
//#include "../lettering/afterword.xbm"
//#include "../lettering/annotator.xbm"
//#include "../lettering/commentator.xbm"
//#include "../lettering/foreword.xbm"
//#include "../lettering/introduction.xbm"
//#include "../lettering/translator.xbm"
#include "../lettering/edition.xbm"
//#include "../lettering/library.xbm"
#include "../lettering/location.xbm"
#include "../lettering/mvreference.xbm"
#include "../lettering/titleaddon.xbm"
#include "../lettering/subtitle.xbm"
#include "../lettering/url.xbm"
#include "../lettering/urldate.xbm"
#include "../lettering/pubstate.xbm"
#include "../lettering/language.xbm"
#include "../lettering/addendum.xbm"
#include "../lettering/note.xbm"
#include "../lettering/annotation.xbm"
#include "../lettering/booktitle.xbm"
#include "../lettering/booksubtitle.xbm"
#include "../lettering/bookaddon.xbm"
#include "../lettering/bookauthor.xbm"
#include "../lettering/institution.xbm"
#include "../lettering/volume.xbm"
#include "../lettering/number.xbm"
#include "../lettering/pages.xbm"
#include "../lettering/publisher.xbm"
#include "../lettering/chapter.xbm"
#include "../lettering/isbn.xbm"
#include "../lettering/series.xbm"
#include "../lettering/shseries.xbm"
#include "../lettering/editor.xbm"
#include "../lettering/sheditor.xbm"
#include "../lettering/eid.xbm"
#include "../lettering/part.xbm"
#include "../lettering/volumes.xbm"
#include "../lettering/month.xbm"
#include "../lettering/version.xbm"
#include "../lettering/organization.xbm"
#include "../lettering/pagetotal.xbm"
#include "../lettering/pagination.xbm"
//#include "../lettering/present.xbm"
//#include "../lettering/authoreditor.xbm"
//#include "../lettering/titled.xbm"
//#include "../lettering/keyword.xbm"
//#include "../lettering/byall.xbm"
//#include "../lettering/bydate.xbm"
//#include "../lettering/bytype.xbm"
//#include "../lettering/byauthor.xbm"
//#include "../lettering/byword.xbm"
//#include "../lettering/clear.xbm"
//#include "../lettering/mvbook.xbm"
//#include "../lettering/mvcollection.xbm"
//#include "../lettering/mvproceedings.xbm"
//#include "../lettering/patent.xbm"
//#include "../lettering/write2.xbm"
//#include "../lettering/minors.xbm"
//#include "../lettering/suppcol.xbm"
#include "../lettering/artwork.xbm"
#include "../lettering/audio.xbm"
#include "../lettering/commentary.xbm"
#include "../lettering/image.xbm"
#include "../lettering/legislation.xbm"
#include "../lettering/legal.xbm"
#include "../lettering/letter.xbm"
#include "../lettering/movie.xbm"
#include "../lettering/music.xbm"
#include "../lettering/performance.xbm"
#include "../lettering/review.xbm"
#include "../lettering/software.xbm"
#include "../lettering/standard.xbm"
#include "../lettering/video.xbm"
#include "../lettering/database.xbm"
#include "../lettering/jurisdiction.xbm"


int    tray[TRAY_SIZE], tray_width, tray_height;

int main()
{
  int    i, j, index, value, counter, k, kk;
  void   process(char *, char*, int, int, int, int);

  for (i=0; i<TRAY_SIZE; i++)  tray[i] = 0;
       /* setup the type tray size */
  tray_width = 900;
//  tray_height = 85;
//  tray_height = 186;
//  tray_height = 400;
//  tray_height = 304;
//  tray_height = 285;
//  tray_height = 394;
//  tray_height = 340;
//  tray_height = 250;
//  tray_height = 177;
//  tray_height = 220;
//  tray_height = 330;
//  tray_height = 370;
//  tray_height = 300;
  tray_height = 220;
//  tray_height = 286;
//  tray_height = 27;
//  tray_height = 54;
//  tray_height = 65;
//  tray_width = 263;
//  tray_width = 275;
//  tray_width = 270;
//  tray_width = 110;
//  tray_height = 86;
//  tray_height = 120;
//  tray_height = 156;
//  tray_height = 186;
//  tray_height = 400;
//  tray_height = 190;
//  tray_width = 86;
//  tray_height = 17;
//  tray_width = 86;
//  tray_width = 130;
//  tray_width = 103;
//  tray_height = 23;
//  tray_height = 100;
//  tray_width = 879;
  if (tray_width*tray_height > TRAY_SIZE)  {
    printf("TRAY_SIZE (= %d) is to small\n", TRAY_SIZE);
    exit(0);
  }
       /* create the type */
 process("database", database_bits, database_width, database_height, 420, 0);
 process("author", author_bits, author_width, author_height, 5, 48);
 process("title", title_bits, title_width, title_height, 5, 82);
 process("date", date_bits, date_width, date_height, 685, 82);
 process("series", series_bits, series_width, series_height, 5, 116);
 process("version", version_bits, version_width, version_height, 700, 116);
 process("publisher", publisher_bits, publisher_width, publisher_height, 5, 150);
 process("type", type_bits, type_width, type_height, 700, 150);
 process("howpublished", howpublished_bits, howpublished_width, howpublished_height, 5, 184);
// process("jurisdiction", jurisdiction_bits, jurisdiction_width, jurisdiction_height, 425, 5);
// process("journaltitle", journaltitle_bits, journaltitle_width, journaltitle_height, 5, 184);
// process("volume", volume_bits, volume_width, volume_height, 5, 218);
// process("number", number_bits, number_width, number_height, 200, 218);
// process("pages", pages_bits, pages_width, pages_height, 400, 218);
// process("institution", institution_bits, institution_width, institution_height, 7, 256);
// process("pagination", pagination_bits, pagination_width, pagination_height, 5, 294);
  //  process("howpublished", howpublished_bits, howpublished_width, howpublished_height, 5, 184);
  //  process("authortype", authortype_bits, authortype_width, authortype_height, 500, 116);
  //  process("institution", institution_bits, institution_width, institution_height, 5, 150);
  //  process("version", version_bits, version_width, version_height, 700, 116);
  //  process("booktitle", booktitle_bits, booktitle_width, booktitle_height, 5, 184);
  //  process("bookauthor", bookauthor_bits, bookauthor_width, bookauthor_height, 5, 218);
  //  process("organization", organization_bits, organization_width, organization_height, 5, 218);
  //  process("edition", edition_bits, edition_width, edition_height, 7, 82);
  //  process("pagetotal", pagetotal_bits, pagetotal_width, pagetotal_height, 300, 82);
  //  process("subtitle", subtitle_bits, subtitle_width, subtitle_height, 5, 116);
  //  process("shseries", shseries_bits, shseries_width, shseries_height, 550, 116);
  //  process("editor", editor_bits, editor_width, editor_height, 7, 150);
  //  process("sheditor", sheditor_bits, sheditor_width, sheditor_height, 550, 150);
  //  process("isbn", isbn_bits, isbn_width, isbn_height, 7, 184);
  //  process("volumes", volumes_bits, volumes_width, volumes_height, 650, 184);
  //  process("holder", holder_bits, holder_width, holder_height, 5, 116);
  //  process("location", location_bits, location_width, location_height, 7, 188);
  //  process("journaltitle", journaltitle_bits, journaltitle_width, journaltitle_height, 5, 116);
  //  process("author", author_bits, author_width, author_height, 5, 48);
  //  process("editor", editor_bits, editor_width, editor_height, 7, 118);
  //  process("volume", volume_bits, volume_width, volume_height, 5, 145);
  //  process("chapter", chapter_bits, chapter_width, chapter_height, 660, 180);
  //  process("isbn", isbn_bits, isbn_width, isbn_height, 5, 248);
  //  process("part", part_bits, part_width, part_height, 350, 248);
  //  process("volumes", volumes_bits, volumes_width, volumes_height, 650, 248);
  //  process("number", number_bits, number_width, number_height, 400, 110);
  //  process("url", url_bits, url_width, url_height, 5, 144);
  //  process("urldate", urldate_bits, urldate_width, urldate_height, 650, 145);
  //  process("note", note_bits, note_width, note_height, 5, 170);
  //  process("editor", editor_bits, editor_width, editor_height, 5, 141);
  //  process("sheditor", sheditor_bits, sheditor_width, sheditor_height, 550, 141);
  //  process("jsubtitle", jsubtitle_bits, jsubtitle_width, jsubtitle_height, 7, 160);
  //  process("shjounral", shjournal_bits, shjournal_width, shjournal_height, 5, 190);
  //  process("month", month_bits, month_width, month_height, 500, 190);
  //  process("version", version_bits, version_width, version_height, 700, 190);
  //  process("series", series_bits, series_width, series_height, 7, 161);
  //  process("pubstate", pubstate_bits, pubstate_width, pubstate_height, 5, 95);
  //  process("language", language_bits, language_width, language_height, 300, 95);
  //  process("addendum", addendum_bits, addendum_width, addendum_height, 5, 125);
  //  process("isbn", isbn_bits, isbn_width, isbn_height, 7, 304);
  //  process("editor", editor_bits, editor_width, editor_height, 7, 336);
  //  process("annotation", annotation_bits, annotation_width, annotation_height, 5, 5);
//  process("titleaddon", titleaddon_bits, titleaddon_width, titleaddon_height, 5, 5);
//  process("url", url_bits, url_width, url_height, 5, 65);
//  process("urldate", urldate_bits, urldate_width, urldate_height, 650, 65);
//  process("pubstate", pubstate_bits, pubstate_width, pubstate_height, 5, 95);
//  process("language", language_bits, language_width, language_height, 300, 95);
//  process("addendum", addendum_bits, addendum_width, addendum_height, 5, 125);
//  process("annotation", annotation_bits, annotation_width, annotation_height, 5, 155);
       /* output the resulting type */
  printf("#define _width %d\n", tray_width);
  printf("#define _height %d\n", tray_height);
  printf("static unsigned char _bits[] = {\n");
  index = 0;
  k = 0;
  kk = 0;
  for (j=0; j<tray_height; j++)  {
    printf("   ");
    counter = 0;
    value = 0;
    k = 1;
    for (i=0; i<tray_width; i++)  {
      if ( tray[index] == 1 )  value += k;
      index++;
      k = k << 1;
      if ( kk > 10 )  {
        printf("\n   ");
	kk = 0;
      }
      if ( counter == 7 )  {
	if ( value == 0 )  {
	  printf("0x00, ");
	}
	else if ( value > 16 ) printf("0x%2x, ", value);
	     else  printf("0x0%1x, ", value); 
        counter = 0;
//	printf("value = %x\n", value);
	value = 0;
	k = 1;
	kk++;
      }
      else  {
        counter++;
//        value = value << 1;
      }
    }
    for (i=counter; i< 7; i++)  value = value >> 1;   /* flush value */
    if ( value == 0 )  {
      printf("0x00, ");
    }
    else if ( value > 15 ) printf("0x%2x, ", value);
         else  printf("0x0%1x, ", value);
    printf("\n");
    kk = 0;
  }
  printf("};\n");
}


/* Put the given bits into the correct place on the overall tray */

void  process(char string[], char data[], int width, int height, int topx,  int topy)
{
  int   i, j, columns, mask;
  int   k, l, n;
  unsigned char  value;

  printf("/* %s     topx = %d  topy = %d */\n", string, topx, topy);
  j = width % 8;
  columns = width/8;
  if ( j > 0 )  columns++;
  k = topy*tray_width;
  for (j=0; j<height; j++)  {
    l = topx;
    for (i=0; i<columns; i++)  {
      mask = 1;  /* setup the bit set searcher */
      value = data[j*columns + i];
      for (n=0; n<8; n++)  {
        if ( value & mask ) {
	  tray[k + l] = 1;
//	  printf("value = %d  mask = %d  k = %d   l = %d\n",
//	          value, mask, k, l);
	}
	l++;
	mask = mask*2;
      }
    }
    k += tray_width;
  }
}
